orte/class/orte_pointer_array.h File Reference.TH "orte/class/orte_pointer_array.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/class/orte_pointer_array.h \- See \fBompi_bitmap.h\fP for an explanation of why there is a split between OMPI and ORTE for this generic class. 
.SH SYNOPSIS
.br
.PP
\fC#include 'orte_config.h'\fP
.br
\fC#include 'opal/threads/mutex.h'\fP
.br
\fC#include 'opal/class/opal_object.h'\fP
.br

.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBorte_pointer_array_t\fP \fBorte_pointer_array_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBOBJ_CLASS_DECLARATION\fP (\fBorte_pointer_array_t\fP)"
.br
.RI "\fIClass declaration. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBorte_pointer_array_init\fP (\fBorte_pointer_array_t\fP **array, size_t initial_allocation, size_t max_size, size_t block_size)"
.br
.RI "\fIInitialize the pointer array. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBorte_pointer_array_add\fP (size_t *index, \fBorte_pointer_array_t\fP *array, void *ptr)"
.br
.RI "\fIAdd a pointer to the array (Grow the array, if need be). \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBorte_pointer_array_set_item\fP (\fBorte_pointer_array_t\fP *array, size_t index, void *value)"
.br
.RI "\fISet the value of an element in array Automatically extend array if required. \fP"
.ti -1c
.RI "static void * \fBorte_pointer_array_get_item\fP (\fBorte_pointer_array_t\fP *table, size_t index)"
.br
.RI "\fIGet the value of an element in array. \fP"
.ti -1c
.RI "static size_t \fBorte_pointer_array_get_size\fP (\fBorte_pointer_array_t\fP *array)"
.br
.RI "\fIGet the size of the pointer array. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBorte_pointer_array_set_size\fP (\fBorte_pointer_array_t\fP *array, size_t size)"
.br
.RI "\fISet the size of the pointer array. \fP"
.ti -1c
.RI "static void \fBorte_pointer_array_clear\fP (\fBorte_pointer_array_t\fP *array)"
.br
.RI "\fIClear the pointer array. \fP"
.ti -1c
.RI "static void \fBorte_pointer_array_free_clear\fP (\fBorte_pointer_array_t\fP *array)"
.br
.RI "\fIClear the pointer array, freeing any storage. \fP"
.ti -1c
.RI "OMPI_DECLSPEC bool \fBorte_pointer_array_test_and_set_item\fP (\fBorte_pointer_array_t\fP *table, size_t index, void *value)"
.br
.RI "\fITest whether a certain element is already in use. \fP"
.in -1c
.SH "Detailed Description"
.PP 
See \fBompi_bitmap.h\fP for an explanation of why there is a split between OMPI and ORTE for this generic class. 


.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC int orte_pointer_array_add (size_t * location, \fBorte_pointer_array_t\fP * table, void * ptr)"
.PP
Add a pointer to the array (Grow the array, if need be). 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP Pointer to \fBorte_pointer_array_t\fP object (IN) 
.br
\fIptr\fP Pointer to be added to table (IN)
.br
\fI(OUT)\fP Array index where ptr is inserted 
.RE
.PP
\fBReturns:\fP
.RS 4
ORTE_ERROR_code if it fails 
.RE
.PP

.SS "static void orte_pointer_array_clear (\fBorte_pointer_array_t\fP * array)\fC [inline, static]\fP"
.PP
Clear the pointer array. 
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP Pointer to array (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
void
.RE
.PP
Simple inline function to clear the pointer array and reset all counters. 
.SS "static void orte_pointer_array_free_clear (\fBorte_pointer_array_t\fP * array)\fC [inline, static]\fP"
.PP
Clear the pointer array, freeing any storage. 
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP Pointer to array (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
void
.RE
.PP
Simple inline function to clear the pointer array and reset all counters. 
.SS "static void* orte_pointer_array_get_item (\fBorte_pointer_array_t\fP * table, size_t index)\fC [inline, static]\fP"
.PP
Get the value of an element in array. 
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP Pointer to array (IN) 
.br
\fIindex\fP Index of element to be returned (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
Error code. NULL indicates an error. 
.RE
.PP

.SS "static size_t orte_pointer_array_get_size (\fBorte_pointer_array_t\fP * array)\fC [inline, static]\fP"
.PP
Get the size of the pointer array. 
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP Pointer to array (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
size Size of the array
.RE
.PP
Simple inline function to return the size of the array in order to hide the member field from external users. 
.SS "OMPI_DECLSPEC int orte_pointer_array_init (\fBorte_pointer_array_t\fP ** array, size_t initial_allocation, size_t max_size, size_t block_size)"
.PP
Initialize the pointer array. 
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP Address of the pointer array object to be initialized 
.br
\fIinitial_alloc\fP The initial number of elements to be allocated 
.br
\fImax_size\fP Maximum size the array is allowed to reach 
.br
\fIblock_size\fP Number of array elements to be added when increase required
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP Initialization successful 
.br
\fIORTE_ERROR(s)\fP Appropriate error code 
.RE
.PP

.SS "OMPI_DECLSPEC int orte_pointer_array_set_item (\fBorte_pointer_array_t\fP * table, size_t index, void * value)"
.PP
Set the value of an element in array Automatically extend array if required. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP Pointer to \fBorte_pointer_array_t\fP object (IN) 
.br
\fIptr\fP Pointer to be added to table (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
Error code
.RE
.PP
Assumption: NULL element is free element. 
.SS "OMPI_DECLSPEC int orte_pointer_array_set_size (\fBorte_pointer_array_t\fP * array, size_t size)"
.PP
Set the size of the pointer array. 
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP Pointer to array (IN)
.br
\fIsize\fP Desired size of the array
.RE
.PP
Simple function to set the size of the array in order to hide the member field from external users. 
.SS "OMPI_DECLSPEC bool orte_pointer_array_test_and_set_item (\fBorte_pointer_array_t\fP * table, size_t index, void * value)"
.PP
Test whether a certain element is already in use. 
.PP
If not yet in use, reserve it.
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP Pointer to array (IN) 
.br
\fIindex\fP Index of element to be tested (IN) 
.br
\fIvalue\fP New value to be set at element index (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
true/false True if element could be reserved False if element could not be reserved (e.g.in use).
.RE
.PP
In contrary to array_set, this function does not allow to overwrite a value, unless the previous value is NULL ( equiv. to free ). 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
